'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMotion = require('react-motion');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Handle = function (_React$Component) {
  _inherits(Handle, _React$Component);

  function Handle(props) {
    _classCallCheck(this, Handle);

    var _this = _possibleConstructorReturn(this, (Handle.__proto__ || Object.getPrototypeOf(Handle)).call(this, props));

    _this.state = {
      isDragging: false,
      deltaX: 0,
      deltaY: 0
    };
    _this.onMouseMove = _this.onMouseMove.bind(_this);
    _this.onMouseUp = _this.onMouseUp.bind(_this);
    _this.onMouseDown = _this.onMouseDown.bind(_this);
    _this.onTouchStart = _this.onTouchStart.bind(_this);
    _this.onTouchMove = _this.onTouchMove.bind(_this);
    _this.onTouchEnd = _this.onTouchEnd.bind(_this);
    _this.onTouchCancel = _this.onTouchCancel.bind(_this);
    _this.inner = null; // ref
    _this.button = null; // ref
    return _this;
  }

  /* global document:false */


  _createClass(Handle, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(newProps, newState) {
      if (this.state.isDragging && !newState.isDragging) {
        document.addEventListener('mousemove', this.onMouseMove);
        document.addEventListener('mouseup', this.onMouseUp);
      } else if (!this.state.isDragging && newState.isDragging) {
        document.removeEventListener('mousemove', this.onMouseMove);
        document.removeEventListener('mouseup', this.onMouseUp);
      }
    }
  }, {
    key: 'onMouseDown',
    value: function onMouseDown(e) {
      // only left mouse button
      if (e.button !== 0) return;
      var rect = this.button.getBoundingClientRect();
      var deltaX = e.clientX - rect.left;
      var deltaY = e.clientY - rect.top;
      this.setState({
        isDragging: true,
        deltaX: deltaX,
        deltaY: deltaY
      });
      e.stopPropagation();
      e.preventDefault();
      this.props.onCatch(this.props.index, e.clientX, e.clientY, deltaX, deltaY);
    }
  }, {
    key: 'onMouseMove',
    value: function onMouseMove(e) {
      if (!this.state.isDragging) return;
      e.stopPropagation();
      e.preventDefault();
      this.props.onMove(this.props.index, e.clientX, e.clientY, this.state.deltaX, this.state.deltaY);
    }
  }, {
    key: 'onMouseUp',
    value: function onMouseUp(e) {
      this.setState({ isDragging: false });
      e.stopPropagation();
      e.preventDefault();
      this.props.onRelease(this.props.index);
    }
  }, {
    key: 'onTouchStart',
    value: function onTouchStart(e) {
      var rect = this.button.getBoundingClientRect();
      var deltaX = e.touches[0].clientX - rect.left;
      var deltaY = e.touches[0].clientY - rect.top;
      this.setState({
        isDragging: true,
        deltaX: deltaX,
        deltaY: deltaY
      });
      e.stopPropagation();
      e.preventDefault();
      this.props.onCatch(this.props.index, e.touches[0].clientX, e.touches[0].clientY, deltaX, deltaY);
    }
  }, {
    key: 'onTouchMove',
    value: function onTouchMove(e) {
      if (!this.state.isDragging) return;
      e.stopPropagation();
      e.preventDefault();
      this.props.onMove(this.props.index, e.touches[0].clientX, e.touches[0].clientY, this.state.deltaX, this.state.deltaY);
    }
  }, {
    key: 'onTouchEnd',
    value: function onTouchEnd(e) {
      this.setState({ isDragging: false });
      e.stopPropagation();
      e.preventDefault();
      this.props.onRelease(this.props.index);
    }
  }, {
    key: 'onTouchCancel',
    value: function onTouchCancel(e) {
      // console.log('Touch cancelled. What should we do?');
    }
  }, {
    key: 'getElement',
    value: function getElement() {
      return this.button;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var left = Math.round(this.props.left);
      var top = Math.round(this.props.top);
      return _react2.default.createElement(
        _reactMotion.Motion,
        {
          ref: function ref(c) {
            _this2.motion = c;
          },
          defaultStyle: { left: 0, top: 0 },
          style: { left: (0, _reactMotion.spring)(left, this.props.spring), top: (0, _reactMotion.spring)(top, this.props.spring) }
        },
        function (value) {
          return _react2.default.createElement(
            'button',
            {
              ref: function ref(c) {
                _this2.button = c;
              },
              onClick: function onClick(e) {
                // Without this, the click will trigger event on Track
                // and we end up having duplicate event
                e.stopPropagation();
                e.preventDefault();
              },
              onMouseDown: _this2.onMouseDown,
              onTouchStart: _this2.onTouchStart,
              onTouchMove: _this2.onTouchMove,
              onTouchEnd: _this2.onTouchEnd,
              className: 'ReactMotionSliderInput-Handle',
              style: {
                left: value.left + 'px',
                top: value.top + 'px',
                position: 'absolute',
                display: 'block'
              }
            },
            _react2.default.createElement(
              'span',
              {
                ref: function ref(c) {
                  _this2.inner = c;
                },
                className: 'ReactMotionSliderInput-Handle-Inner' },
              _this2.props.value
            ),
            _react2.default.createElement(
              'span',
              { className: 'ReactMotionSliderInput-Handle-Label' },
              _this2.props.value
            )
          );
        }
      );
    }
  }]);

  return Handle;
}(_react2.default.Component);

Handle.propTypes = {
  index: _react2.default.PropTypes.number.isRequired,
  value: _react2.default.PropTypes.oneOfType([_react2.default.PropTypes.string, _react2.default.PropTypes.number]),
  top: _react2.default.PropTypes.number.isRequired,
  left: _react2.default.PropTypes.number.isRequired,
  onCatch: _react2.default.PropTypes.func.isRequired,
  onMove: _react2.default.PropTypes.func.isRequired,
  onRelease: _react2.default.PropTypes.func.isRequired,
  // React-motion spring config
  spring: _react2.default.PropTypes.shape({
    stiffness: _react2.default.PropTypes.number,
    damping: _react2.default.PropTypes.number,
    precision: _react2.default.PropTypes.number
  }).isRequired
};

exports.default = Handle;