'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactMotion = require('react-motion');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Range = function (_React$Component) {
  _inherits(Range, _React$Component);

  function Range(props) {
    _classCallCheck(this, Range);

    var _this = _possibleConstructorReturn(this, (Range.__proto__ || Object.getPrototypeOf(Range)).call(this, props));

    _this.onClick = _this.onClick.bind(_this);
    _this.element = null;
    return _this;
  }

  _createClass(Range, [{
    key: 'onClick',
    value: function onClick(e) {
      this.props.onClick(e.clientX, e.clientY);
      e.stopPropagation();
      e.preventDefault();
    }
  }, {
    key: 'getElement',
    value: function getElement() {
      return this.element;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var className = 'ReactMotionSliderInput-Range' + (this.props.className ? ' ' + this.props.className : '');
      var top = Math.round(this.props.top);
      var left = Math.round(this.props.left);
      var width = Math.round(this.props.width);
      var height = Math.round(this.props.height);
      return _react2.default.createElement(
        _reactMotion.Motion,
        {
          defaultStyle: { left: 0, top: 0, width: 0, height: 0 },
          style: {
            left: (0, _reactMotion.spring)(left, this.props.spring),
            top: (0, _reactMotion.spring)(top, this.props.spring),
            width: (0, _reactMotion.spring)(width, this.props.spring),
            height: (0, _reactMotion.spring)(height, this.props.spring)
          }
        },
        function (value) {
          return _react2.default.createElement('span', {
            ref: function ref(c) {
              _this2.element = c;
            },
            onClick: _this2.onClick,
            role: 'button',
            tabIndex: -1,
            style: {
              left: value.left + 'px',
              top: value.top + 'px',
              width: value.width + 'px',
              height: value.height + 'px',
              position: 'absolute',
              display: 'block'
            },
            className: className
          });
        }
      );
    }
  }]);

  return Range;
}(_react2.default.Component);

Range.propTypes = {
  left: _react2.default.PropTypes.number.isRequired,
  top: _react2.default.PropTypes.number.isRequired,
  width: _react2.default.PropTypes.number.isRequired,
  height: _react2.default.PropTypes.number.isRequired,
  onClick: _react2.default.PropTypes.func.isRequired,
  className: _react2.default.PropTypes.string,
  spring: _react2.default.PropTypes.shape({
    stiffness: _react2.default.PropTypes.number,
    damping: _react2.default.PropTypes.number,
    precision: _react2.default.PropTypes.number
  }).isRequired
};
exports.default = Range;